// console.log( "not ready." );
var MBESL = MBESL || {};
MBESL.settings = MBESL.settings || {};

MBESL.registerSocialMediaListeners = function() {
	jQuery('#social-medias input').change(function(e) {
		MBESL.getEnabledSocials();
		MBESL.toggleSocialMediaOptions(e.currentTarget.id);
		MBESL.toggleSocialMediaActive(e.currentTarget.id);
		MBESL.changeSocialMediaLocation(e.currentTarget.id);
		MBESL.updatePreview();
		MBESL.saveOptions();
	});
};

MBESL.registerGeneralOptionsListeners = function() {
	MBESL.settings = MBESL.settings || {};
	MBESL.settings.generalOptions = MBESL.settings.generalOptions || {};
	jQuery('#mbesl-open-in-new-tab').change(function(e) {
		MBESL.settings.generalOptions.openInNewTab = jQuery('#mbesl-open-in-new-tab')[0].checked;
		MBESL.saveOptions();
	});
};

MBESL.updatePreview = function() {
	MBESL.settings.socialMediaEnabled = MBESL.settings.socialMediaEnabled || [];

	if (MBESL.settings.socialMediaEnabled.length) {
		jQuery('.mbesl-preview-container').removeClass('hidden');
		jQuery('#mbesl-instructions').addClass('hidden');
	}
	else {
		jQuery('.mbesl-preview-container').addClass('hidden');
		jQuery('#mbesl-instructions').removeClass('hidden');
	}

	jQuery('#mbesl-preview').html("");
	var mbeslhtml = '<div class="mbesl-template-basic">'; /* dynamically set template name */
		mbeslhtml += '<ul class="fa-ul">';
	for (var i = 0; i < MBESL.settings.socialMediaEnabled.length; i++) {
		var socialMediaId = MBESL.settings.socialMediaEnabled[i];
		mbeslhtml += '<li>';
		mbeslhtml += '<a href="'+MBESL.settings.socialMediaOptions[socialMediaId].url+'" target="_blank">';
		mbeslhtml += '<i class="fa-li fa fa-'+ MBESL.settings.socialMediaEnabled[i] +'"></i>';
		mbeslhtml += '<span class="label">' + MBESL.settings.socialMediaOptions[socialMediaId].label + '</span>';
		mbeslhtml += '</a>';
		mbeslhtml += '</li>';
	}
	mbeslhtml += '</ul>';
	mbeslhtml += '</div>';
	jQuery('#mbesl-preview').html(mbeslhtml);
};

MBESL.getEnabledSocials = function() {
	MBESL.settings.socialMediaEnabled = [];
	jQuery('#social-medias input:checked').each(function(i) {
		var socialMediaId = jQuery(this).attr('name');
	    MBESL.settings.socialMediaEnabled.push(socialMediaId);
	    MBESL.setSocialMediaOrder(i,socialMediaId);
	});
	MBESL.getSocialMediaOptions();
}

MBESL.setSocialMediaOrder = function(order, socialMediaId) {
	jQuery('#'+socialMediaId+'-order').val(order);
}

MBESL.toggleSocialMediaOptions = function(socialMediaId){
	var socialMediaOptions = "." + socialMediaId + "-options";
	jQuery(socialMediaOptions).toggle();
};

MBESL.toggleSocialMediaActive = function(socialMediaId){
	var socialMediaCard = "#" + socialMediaId + "-card";
	jQuery(socialMediaCard).toggleClass('active');
};

MBESL.changeSocialMediaLocation = function(socialMediaId){
	var socialMediaCard = jQuery("#" + socialMediaId + "-card");
	if(jQuery.inArray(socialMediaId, MBESL.settings.socialMediaEnabled) !== -1) {
		jQuery('.active-social-medias').append(socialMediaCard);
	} else {
		jQuery('.inactive-social-medias').append(socialMediaCard);
	}
};

MBESL.getSocialMediaOptions = function(){
	MBESL.settings = MBESL.settings || {};
	MBESL.settings.socialMediaEnabled = MBESL.settings.socialMediaEnabled || [];
	MBESL.settings.socialMediaOptions = MBESL.settings.socialMediaOptions || {};
	for (var i = 0; i < MBESL.settings.socialMediaEnabled.length; i++) {
		socialMediaId = MBESL.settings.socialMediaEnabled[i];
		MBESL.settings.socialMediaOptions[socialMediaId] = MBESL.settings.socialMediaOptions[socialMediaId] || {};
		MBESL.settings.socialMediaOptions[socialMediaId].url = jQuery('#'+socialMediaId+'-url').val();
		MBESL.settings.socialMediaOptions[socialMediaId].label = jQuery('#'+socialMediaId+'-label').val();
		MBESL.settings.socialMediaOptions[socialMediaId].order = jQuery('#'+socialMediaId+'-order').val();
		if  (MBESL.settings.socialMediaOptions[socialMediaId].order.length == 0)
			delete MBESL.settings.socialMediaOptions[socialMediaId].order;
	}
};

MBESL.saveOptions = function(){
	MBESL.setStatus('<i class="fa fa-cog fa-spin fa-fw"></i><span class="sr-only">Saving...</span> Saving...');
	var data = {
		action: 'settings_update',
		security: MBESL.security,
		settings: MBESL.settings
	};
	jQuery.post(MBESL.ajaxurl, data, function(response) {
		// console.log(response);
		switch(response.status)
		{
			case 200:
			default:
			MBESL.setStatus("Saved!");
			break;
		}
	});
};

MBESL.copyShortcode = function(){
	document.querySelector('#mbesl-shortcode').select();
	document.execCommand('copy');
	MBESL.setStatus("Copied shortcode!");
};

MBESL.registerShortcodeCopyListener = function(){
	jQuery('#mbesl-shortcode-copy').click(function(e) {
		e.preventDefault();
		MBESL.copyShortcode();
	});
};

MBESL.setStatus = function(statusMessage) {
  var status = document.getElementById("mbesl-status");
  jQuery('#mbesl-status').html("<p>"+statusMessage+"</p>");
  status.className = "show";
  MBESL.statusTimeout = setTimeout(function(){ status.className = status.className.replace("show", ""); }, 3000);
}

MBESL.registerSortable = function(){
	jQuery( ".active-social-medias" ).sortable({
      connectWith: ".sortable",
      handle: ".social-media-header",
      placeholder: "sortable-placeholder",
      stop: function(){
      	MBESL.getEnabledSocials();
		MBESL.updatePreview();
		MBESL.saveOptions();
      }
    });
};

jQuery(function() {
    MBESL.updatePreview();
    MBESL.registerSortable();
    MBESL.registerSocialMediaListeners();
    MBESL.registerGeneralOptionsListeners();
    MBESL.registerShortcodeCopyListener();
});