<?php
/*
Plugin Name: Easy Social Links
Plugin URI: https://www.mocha-bear.com/easy-social-links
Description: Easily configure and display links to your social media profile using a shortcode
Version: 1.0.4
Author: Mocha Bear Team
Author URI: https://www.mocha-bear.com
Text Domain: mbesl
*/

namespace Mochabear\EasySocialLinks;

use Mochabear\EasySocialLinks\Includes\MBESL_Submenu as Submenu;
use Mochabear\EasySocialLinks\Includes\MBESL_Shortcode as Shortcode;

if( ! defined( 'ABSPATH' ) ) die('Not allowed');

class MBEasySocialLinks {

	public $version = '1.0.4';
	public $Submenu;
	public $Shortcode;

	function __construct() {}

	function init() {
		$this->load_classes();
		$this->check_version();
	}

	function load_classes() {
		require_once 'includes/class-base.php';
		require_once 'includes/class-submenu.php';
		require_once 'includes/class-shortcode.php';
		$this->Submenu = new Submenu();
		$this->Shortcode = new Shortcode();
	}

	function check_version() {
		/* Save plugin version */
		if (get_option('mbesl-version', false) == false) {
			update_option( 'mbesl-version', $this->version );
		} else if (get_option('mbesl-version', false) < $this->version) {
			// Upgrading
			update_option( 'mbesl-version', $this->version );
		} else if (get_option('mbesl-version', false) > $this->version) {
			// Downgrading
			update_option( 'mbesl-version', $this->version );
		}
	}
}

function MBEasySocialLinks() {
	global $mbesl;
	
	// Instantiate only once.
	if( !isset($mbesl) ) {
		$mbesl = new MBEasySocialLinks();
		$mbesl->init();
	}
	return $mbesl;
}

MBEasySocialLinks();
