<?php

namespace Mochabear\EasySocialLinks\Includes;

if( ! defined( 'ABSPATH' ) ) die('Not allowed');

class MBESL_Shortcode extends MBESL_Base {

	function __construct()
	{
		parent::__construct();
		add_action( 'init', array( $this, 'register_shortcodes' ) );
		add_action( 'wp_enqueue_scripts', array( $this, 'enqueue_mbesl_assets' ) );
	}

	function register_shortcodes(){
		add_shortcode( 'easy_social_links', array( $this, 'mbesl_function' ) );
	}

	function enqueue_mbesl_assets()
	{
	    wp_enqueue_style(
	      'fork-awesome',
	      $this->plugins_url . '/assets/lib/fork-awesome/css/fork-awesome.min.css',
	      array(), 
	      true,
	      'all'
	    );
	}

	function mbesl_function()
	{

		$settings = get_option($this->settings_option, false);

		if ( $settings == false ) {
			echo "Easy Social Links has not been configured yet.";
			return;
		}

		$generalOptions = isset( $settings['generalOptions'] ) ? $settings['generalOptions'] : array();
		$openInNewTab = isset( $generalOptions->openInNewTab ) ? $generalOptions->openInNewTab : "false";
		$aTargetHTML = $openInNewTab == "true"? 'target="_blank"' : "";

		$socialMediaEnabled = isset( $settings['socialMediaEnabled'] ) ? $settings['socialMediaEnabled'] : array();
		$socialMediaOptions = isset( $settings['socialMediaOptions'] ) ? $settings['socialMediaOptions'] : array();

		$socialMediaHTML = "";
		foreach ($socialMediaEnabled as $socialMediaId) {
			$url = $socialMediaOptions[$socialMediaId]['url'];
			$label = $socialMediaOptions[$socialMediaId]['label'];
			$socialMediaHTML .= <<<EOT
<li>
	<a href="{$url}" {$aTargetHTML}>
		<i class="fa-li fa fa-{$socialMediaId}"></i>
		<span class="esl-label">{$label}</span>
	</a>
</li>
EOT;

		}

		$html = <<<EOT
<div class="mbesl-template-basic">
	<ul class="fa-ul">
		{$socialMediaHTML}
	</ul>
</div>
EOT;

		return $html;
	}

}